---
layout: default
extra_css:
  - home.css
  - maturity.css
extra_js:
  - libs/on-scroll.js
  - home.js
  - all-clickable.js
  - libs/moment.min.js
  - maturity.js
title: "Maturity"
---

.container
  
  .maturity-intro
    %p
      GitLab has a 
      = succeed "," do 
        %a{href: "/direction/"} broad scope and vision
      and we are constantly 
      %a{href: "/handbook/values/#iteration"} iterating
      on existing and new features. Some features are more mature and polished than others. To better convey the state of our feature set and be 
      = succeed "," do 
        %a{href: "/handbook/values/#transparency"} transparent
      we have developed a maturity framework.

    %p
      Each feature and 
      %a{href: "/handbook/product/application-types/"} application type
      is grouped into a 
      = succeed "," do
        %a{href: "/handbook/product/categories/"} category
      representing high-level capabilities. Every category is then assigned one of five maturities:
      = partial "includes/product/maturity_legend"

.container
  %section.maturity-tables

    %h2 Category maturity

    .sdlc-container.position-relative#maturity-no-padding
      .sdlc-table
        - Gitlab::Homepage::Stage.all!.select{|stage| stage.marketing}.each do |stage|
          .sdlc-column
            .stage-container
              %a{href: "##{stage.key}"}
                = partial "/includes/icons/sdlc-icons/#{stage.key}.svg"
              %a{href: "##{stage.key}"}
                %p #{stage.display_name}
            .solutions-container
              - category_keys_active = data.categories.keys.keep_if { |k| data.categories[k].stage == stage.key && data.categories[k].available && data.categories[k].available <= Date.today}
              - category_keys_upcoming = data.categories.keys.keep_if { |k| data.categories[k].stage == stage.key && data.categories[k].available && data.categories[k].available > Date.today}
              - if category_keys_active.length >= 1
                .current-categories
                  %p.font-bold
                    Since
                    #{stage.established}
                    GitLab added:
                  .stage-column
                    .category-list
                      - category_keys_active.each do |key|
                        .category
                          .category-cell
                            %a{ href: "##{key}"}
                              = partial "/images/maturity/#{maturity(data.categories[key], Date.today)}.svg"
                          .category-cell
                            - url = data.categories[key].alt_link ? data.categories[key].alt_link : "/product/#{key.tr('_', '-').downcase}/"
                            %a{ href: "#{url}" } #{data.categories[key].name}
              - if category_keys_upcoming.length >= 1
                .future-categories
                  %p.font-bold
                    On our
                    = succeed ':' do
                      %br
                      %a.font-bold{ href: "#{stage.vision}"} roadmap
                  .stage-column
                    .category-list
                      - category_keys_upcoming.each do |key|
                        .category
                          .category-cell
                            %a{ href: "##{key}"}
                              = partial "/images/maturity/#{maturity(data.categories[key], Date.today)}.svg"
                          .category-cell
                            - url = data.categories[key].alt_link ? data.categories[key].alt_link : "/product/#{key.tr('_', '-').downcase}/"
                            %a{ href: "#{url}" } #{data.categories[key].name}

    %h3#maturity-plan Category Maturity plan

    - data.stages.stages.each do |stageKey, stage|
      - categories = data.categories.select{|catKey,cat| cat.stage==stageKey && !cat.hide && !cat.available.blank?}
      - next if categories.empty?
      %a.scroll-anchor{id: "#{stageKey}"}
      %table.stage-table
        %col{width: "300"}
        %tbody
          %tr
            %td{:colspan => 6, style: "padding: 0"}
              %table.stage-header
                %tr.stage-row
                  %td.stage-icon
                    %a{href: "/stages-devops-lifecycle/#{stageKey}/"}
                      = partial "/includes/icons/sdlc-icons/#{stageKey}.svg"
                    %a{href: "/stages-devops-lifecycle/#{stageKey}/"}
                      %p #{stage.display_name}
                  %td.stage-maturity
                    %p
                      = succeed ":" do
                        %a{href: "#stage-lifecycle"} Stage Lifecycle
                      #{stage.lifecycle}
                    %p
                      = succeed ":" do
                        %a{href: "/analysts"} Analyst Reports
                      %ul
                        - if stage.analyst_reports
                          - stage.analyst_reports.each do |report|
                            %li 
                              %a{href: "#{report.url}"} #{report.title}
                  %td.stage-contributions
                    %p
                      = succeed ":" do
                        %a{href: "/handbook/marketing/community-relations/code-contributor-program/#bitergia-dashboard"} Community Contributions
                    %p
                      %span
                        #{stage.contributions} 
                      in the last 3 months
            %tr
              %td
                Category
              %td.text-center
                Today
              %td.text-center
                Q1
              %td.text-center
                Q2
              %td.text-center
                Q3
              %td.text-center
                Q4
            %tr
              %td
                %i Date
              %td.text-center
                %i 
                  %span.today
              %td.text-center
                %i 2019-04-30
              %td.text-center
                %i 2019-07-31
              %td.text-center
                %i 2019-10-31
              %td.text-center
                %i 2020-01-31
          - categories.each do |categoryKey, category|
            %tr
              %td
                %a.scroll-anchor{id: "#{categoryKey}"}
                - if category.vision 
                  %a{href: "#{category.vision}"} #{category.name}
                - else
                  = category.name
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(category, Date.today)}.svg"
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(category, Date.new(2019,04,30))}.svg"
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(category, Date.new(2019,07,31))}.svg"
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(category, Date.new(2019,10,31))}.svg"
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(category, Date.new(2020,01,31))}.svg"

    %h2#stage-lifecycle Stage Lifecycle
    %p
      Stages at GitLab evolve through a fairly predictable maturity cycle. The phases typically evolve on a yearly basis, with adoption growing as more use cases are addressed. The journey that we have found is:
    %ol{start: "0"}
      %li Not yet available
      %li Not used at GitLab Inc.
      %li Majority of users work at GitLab Inc.
      %li Majority of users don’t work at GitLab Inc.
      %li Usable for most GitLab users
      %li Users of other tools start to switch
      %li Entry point for new customers
      %li Best product in the market

    %h2 Changes
    %p
      Learn how to make changes to categories and their maturity on our 
      = succeed "." do
        %a{ href: "../../handbook/marketing/website/#working-with-category-maturity"} website handbook page